function raceExpandedFrame_OnLoad()
  local frame = RaceExpandedFrame
  tinsert(UISpecialFrames, frame:GetName())
  
  npcGenerator_NPC_Frame.Race.ExpandButton:SetScript("OnClick", function()
    if frame:IsVisible() then
      frame:Hide()
    else
      if frame:GetParent().activeExpandedFrame then
        frame:GetParent().activeExpandedFrame:Hide()
      end
      frame:GetParent().activeExpandedFrame = frame
      frame:Show()
    end
  end)
end

function dropdownFactionButton_OnClick(self, button, down)
  ToggleDropDownMenu(1, nil, RaceExpandedFrame.Panel.FactionDropDownMenu, RaceExpandedFrame.Panel.FactionDropDownButton:GetName(), 0, 0)
end

function dropdownMenu_Initialize(self, level)
  

  local info = UIDropDownMenu_CreateInfo()
  
  info.text     = "All"
  info.func     = function(button, arg1, arg2)
    UIDropDownMenu_SetSelectedValue(RaceExpandedFrame.Panel.FactionDropDownButton, arg1)
    NPCG_Options.raceSettings.factionMatchingMode = "All"
    end
  info.arg1     = "All"
  info.arg2     = "nuh!"
  UIDropDownMenu_AddButton(info)
  
  info          = UIDropDownMenu_CreateInfo()
  info.text     = "Context-based"
  info.func     = function(button, arg1, arg2) 
    UIDropDownMenu_SetSelectedValue(RaceExpandedFrame.Panel.FactionDropDownButton, arg1)
    NPCG_Options.raceSettings.factionMatchingMode = "Context-based"
    end
  info.arg1     = "Context-based"
  info.arg2     = "nuh!"
  UIDropDownMenu_AddButton(info)
  
  info          = UIDropDownMenu_CreateInfo()
  info.text     = "Faction-based"
  info.func     = function(button, arg1, arg2)
    UIDropDownMenu_SetSelectedValue(RaceExpandedFrame.Panel.FactionDropDownButton, arg1)
    NPCG_Options.raceSettings.factionMatchingMode = "Faction-based"
    end
  info.arg1     = "Faction-based"
  info.arg2     = "nuh!"
  UIDropDownMenu_AddButton(info)
  -- I can't reach npcG options here.
end

function dropdownMenu_OnLoad(self)
  UIDropDownMenu_Initialize(self, dropdownMenu_Initialize)
end

